#!/bin/bash

case $1 in
    sda)
	ID=1
	SRC=sdb
	;;
    sdb)
	ID=2
	SRC=sda
	;;
    *)
	echo "Pouziti: $0 vymeneny_disk"
	echo "Napriklad $0 sda"
	exit 0
	;;
esac

echo "Pred spustenim kazde kriticke operace 
vypise co a s jakymi parametry bude skript delat.
Pote ceka na stisknutí klavesy enter.
Pomoci CTRL+C lze operaci prerusit.

NEPOUSTEJTE skript dvakrat po sobe. Bude se chovat nedefinovane!

Pro pokracovani stiskni enter.
"
read i || exit 0

DISK=$1

puppet agent --disable
killall kvm
sleep 5
umount /data/raid0/

RAID0=`awk '/md.*(raid0|inactive)/{print $1}' /proc/mdstat`

RAID11=`awk  '/md.*1\[/{print $1}' /proc/mdstat`
RAID12=`awk  '/md.*2\[/{print $1}' /proc/mdstat`
RAID13=`awk  '/md.*3\[/{print $1}' /proc/mdstat`


echo "MD stat:"

cat /proc/mdstat

echo
echo "Odstranim $RAID0"
echo "Odstranim disk /dev/${DISK}1 z /dev/$RAID11"
echo "Odstranim disk /dev/${DISK}2 z /dev/$RAID12"
echo "Odstranim disk /dev/${DISK}3 z /dev/$RAID13"
echo "Stiskni enter"
read i || exit 0

mdadm --stop /dev/$RAID0
mdadm --manage /dev/$RAID11 -r /dev/${DISK}1
mdadm --manage /dev/$RAID12 -r /dev/${DISK}2
mdadm --manage /dev/$RAID13 -r /dev/${DISK}3

echo "Povoluji vymeneny disk..."
hpssacli ctrl slot=0 ld $ID modify reenable forced


cat /proc/mdstat

echo "----"

cat /proc/mdstat | grep $DISK | tr '[' ' ' | while read i; do
  MD=`echo "$i" | awk '{print $1}'`
  SB=`echo "$i" | sed -e 's/.*\('"$DISK"'.\).*/\1/'`

  echo "zastavim MD $MD a smazu superblock na $SB"

done

echo "A stiskni enter"
read i || exit 0

cat /proc/mdstat | grep $DISK | tr '[' ' ' | while read i; do
  MD=`echo "$i" | awk '{print $1}'`
  SB=`echo "$i" | sed -e 's/.*\('"$DISK"'.\).*/\1/'`

  echo "zastavuji MD $MD a smazu superblock na $SB"

  mdadm --stop "/dev/$MD"
  mdadm --zero-superblock "/dev/$SB"

done

echo "Klonuji part table z disku $SRC na disk $DISK"
echo "A stiskni enter"
read i || exit 0

sfdisk -d /dev/$SRC | sfdisk --force /dev/$DISK
sleep 5

echo "Přidávám disky do MD..."
mdadm --manage /dev/$RAID11 -a /dev/${DISK}1
mdadm --manage /dev/$RAID12 -a /dev/${DISK}2
mdadm --manage /dev/$RAID13 -a /dev/${DISK}3

mdadm --create --assume-clean --level=0 --raid-devices=2 --name=raid0 /dev/md/raid0 /dev/sda5 /dev/sdb5

echo "Zapisuji mdadm.conf..."
cp -f /etc/mdadm.conf /etc/mdadm.conf-
cat - >/etc/mdadm.conf <<EOF
MAILADDR root
AUTO +imsm +1.x -all
EOF

mdadm --detail --scan | sed -e 's/spares=[^ ]*//' >>/etc/mdadm.conf

echo "Dracut regenerate..."
dracut --regenerate-all -f

echo "GRUB install..."
echo /dev/sda /dev/sdb | xargs -n 1 grub2-install

echo "hpssacli bootvolume..."
hpssacli ctrl slot=0 logicaldrive 1 modify bootvolume=primary
hpssacli ctrl slot=0 logicaldrive 2 modify bootvolume=secondary

echo "mkfs.ext4 raid0..."
mkfs.ext4 -F -m0 -L raid0 /dev/md/raid0

echo "FSTAB edit..."
OLDUUID=`awk '/raid0/{print $1}' /etc/fstab`
NEWUUID=`blkid /dev/md/raid0 | tr -d '"' | awk '{print $3}'`

sed -i -e 's/'$OLDUUID'/'$NEWUUID'/' /etc/fstab

echo "Dokonceni..."
mount -a
puppet agent --enable
puppet agent -t

